// SPDX-License-Identifier: BSD-3-Clause

#ifndef INVERTER_TOOLS_PROTOCOL_CLIENT_H
#define INVERTER_TOOLS_PROTOCOL_CLIENT_H

#include "../voltronic/device.h"
#include "response.h"

namespace protocol {

class BaseClient {
private:
    std::shared_ptr<voltronic::Device> device_;

public:
    void setDevice(std::shared_ptr<voltronic::Device> device);
    virtual std::shared_ptr<BaseResponse> execute(int commandType, std::vector<std::string>& arguments) = 0;
    std::pair<std::shared_ptr<char>, size_t> runOnDevice(std::string& raw);
};

}

#endif //INVERTER_TOOLS_PROTOCOL_CLIENT_H
