// SPDX-License-Identifier: BSD-3-Clause

#ifndef INVERTER_TOOLS_P17_TYPES_H
#define INVERTER_TOOLS_P17_TYPES_H

namespace p17 {

enum class CommandType: int {
    GetProtocolID = 0,
    GetCurrentTime,
    GetTotalGenerated,
    GetYearGenerated,
    GetMonthGenerated,
    GetDayGenerated,
    GetHourGenerated,
    GetSeriesNumber,
    GetCPUVersion,
    GetSecondaryCPUVersion,
    GetDeviceModel,
    GetRatedInformation,
    GetGeneralStatus,
    GetPowerStatus,
    GetWorkingMode,
    GetWarningStatus,
    GetFlags,
    GetACInputVoltageRange,
    GetACInputFrequencyRange,
    GetMaximumGridOutputPower,
    GetMaximumOutputPower,
    GetSolarInputMPPTRange,
    GetSolarInputVoltageRange,
    GetLCDSleepTimeout,
    GetDefaults,
    GetBatterySettings,
    GetMachineModel,
    GetMachineAdjustableRanges,
    GetFaults,
    GetFaultsHistory,
    GetEnergyControlStatus,
    GetACInputLongTimeHighestAvgVoltage,
    GetFirstGeneratedEnergySavedTime,
    GetFeedWaitTime,
    GetACChargingTimeBucket,
    GetACLoadsSupplyTimeBucket,
    GetFeedingGridPowerCalibration,
    GetFeedInPowerFactor,
    GetAutoAdjustPFWithPowerInformation,
    GetAllowOneOfSTPhaseLossStatus,
    SetLoads = 100,
    SetFlag,
    SetDateTime,
    SetACInputHighestVoltageForFeedingPower,
    SetACInputLowestVoltageForFeedingPower,
    SetACInputHighestFrequencyForFeedingPower,
    SetACInputLowestFrequencyForFeedingPower,
    SetMaxOutputPower,
    SetMaxFeedingGridPower,
    SetSolarInputHighestVoltage,
    SetSolarInputLowestVoltage,
    SetSolarInputHighestMPPTVoltage,
    SetSolarInputLowestMPPTVoltage,
    SetLCDSleepTimeout,
    SetBatteryMaxChargingCurrent,
    SetBatteryMaxACChargingCurrent,
    SetBatteryMaxChargingVoltage,
    SetACInputLongTimeHighestAverageVoltage,
    SetBatteryDischargingVoltage,
    SetSolarEnergyDistributionOfPriority,
    SetEnergyDistribution,
    SetBatteryChargerApplicationInFloatingCharging,
    SetMachineModel,
    SetDefaults,
    SetACOutputFreq,
    SetACOutputRatedVoltage,
    SetFeedWaitTime,
    SetACChargingTimeBucket,
    SetACLoadsSupplyTimeBucket,
    SetBatteryType,
    SetBatteryInstallTime,
    SetLiFeBatterySelfTest,
    SetACChargerKeepBatteryVoltageSetting,
    SetBatteryTempSensorCompensation,
    SetFeedingGridPowerCalibration,
    SetBatteryMaxDischargingCurrentInHybridMode,
    SetFeedInPowerFactor,
    SetParallelOutput,
    SetRPhaseFeedingGridPowerCalibration, // ???
    SetSPhaseFeedingGridPowerCalibration, // ???
    SetTPhaseFeedingGridPowerCalibration, // ???
    SetAutoAdjustPFWithPowerInformation,
    SetAllowOneOfSTPhaseLoss,
    SetEmergencyPowerSupplyControl,
};

struct Flag {
    std::string flag;
    char letter;
    std::string description;
};

}

#endif //INVERTER_TOOLS_P17_TYPES_H