// SPDX-License-Identifier: BSD-3-Clause

#ifndef INVERTER_TOOLS_P18_CLIENT_H_
#define INVERTER_TOOLS_P18_CLIENT_H_

#include "../voltronic/device.h"
#include "types.h"
#include "response.h"
#include "../protocol/client.h"

#include <memory>
#include <vector>
#include <string>


namespace p18 {

using protocol::BaseClient;
using protocol::BaseResponse;

class Client : public BaseClient {
private:
    static std::string packArguments(p18::CommandType commandType, std::vector<std::string>& arguments);

public:
    std::shared_ptr<BaseResponse> execute(int commandType, std::vector<std::string>& arguments) override;
};

}


#endif //INVERTER_TOOLS_P18_CLIENT_H_
